let convict = require("convict");

let configSchema = {
  launchTime: {
    doc: 'Time Convict was loaded',
    format: 'string',
    env: 'TIME'
  },
  port: {
    doc: 'The port to bind.',
    format: 'int',
    default: 8080,
    env: 'PORT',
    providerPath: '/port'
  }
 };;


let provider = function(configSchema){
    // simulating an outside data source
    let customKeyValueStore = {
        '/port': 8000
    }
    
    let obj = {};
    
    obj.launchTime = Date.now();
    obj.port = customKeyValueStore[configSchema.port.providerPath]
    
    return obj;
};

console.log(provider(configSchema));

let conf = convict(configSchema).load(provider(configSchema));;

module.exports = conf.getProperties()

// in another module...
// let config = require('./config')
// console.log(config) ;
